package guest;
 
import java.sql.Date;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.ejb.Stateful;
import javax.ejb.Stateless;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.PersistenceContextType;
import javax.persistence.PersistenceException;
import javax.persistence.TypedQuery;
 
@Stateful
public class GuestDao {
    // Injected database connection:
    @PersistenceContext(type=PersistenceContextType.EXTENDED)
    private EntityManager em;
    
    private TypedQuery<Guest> findGuestQuery;
 
    // Stores a new guest:
    public void persist(Guest guest) {
        em.persist(guest);
        
        
        
        
        
    }
 
    // Retrieves all the guests:
    public List<Guest> getAllGuests() {
        TypedQuery<Guest> query = em.createQuery(
            "SELECT g FROM Guest g ORDER BY g.id", Guest.class);
        return query.getResultList();
    }
    
    
    
    @PostConstruct
    public void createFindGuestQuery(){
    	
    	this.findGuestQuery=em.createQuery("SELECT g from Guest g WHERE g.name=:name",Guest.class);
    }
    
    public Guest findGuest(String name) throws PersistenceException{
    	
    	findGuestQuery.setParameter("name",name);
    	
    	return findGuestQuery.getSingleResult();
    }
    
   
}